/*
Copyright 2020 The KubeSphere Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha2 "kubesphere.io/kubesphere/pkg/apis/iam/v1alpha2"
	scheme "kubesphere.io/kubesphere/pkg/client/clientset/versioned/scheme"
)

// RoleBasesGetter has a method to return a RoleBaseInterface.
// A group's client should implement this interface.
type RoleBasesGetter interface {
	RoleBases() RoleBaseInterface
}

// RoleBaseInterface has methods to work with RoleBase resources.
type RoleBaseInterface interface {
	Create(*v1alpha2.RoleBase) (*v1alpha2.RoleBase, error)
	Update(*v1alpha2.RoleBase) (*v1alpha2.RoleBase, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha2.RoleBase, error)
	List(opts v1.ListOptions) (*v1alpha2.RoleBaseList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha2.RoleBase, err error)
	RoleBaseExpansion
}

// roleBases implements RoleBaseInterface
type roleBases struct {
	client rest.Interface
}

// newRoleBases returns a RoleBases
func newRoleBases(c *IamV1alpha2Client) *roleBases {
	return &roleBases{
		client: c.RESTClient(),
	}
}

// Get takes name of the roleBase, and returns the corresponding roleBase object, and an error if there is any.
func (c *roleBases) Get(name string, options v1.GetOptions) (result *v1alpha2.RoleBase, err error) {
	result = &v1alpha2.RoleBase{}
	err = c.client.Get().
		Resource("rolebases").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of RoleBases that match those selectors.
func (c *roleBases) List(opts v1.ListOptions) (result *v1alpha2.RoleBaseList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha2.RoleBaseList{}
	err = c.client.Get().
		Resource("rolebases").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested roleBases.
func (c *roleBases) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("rolebases").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a roleBase and creates it.  Returns the server's representation of the roleBase, and an error, if there is any.
func (c *roleBases) Create(roleBase *v1alpha2.RoleBase) (result *v1alpha2.RoleBase, err error) {
	result = &v1alpha2.RoleBase{}
	err = c.client.Post().
		Resource("rolebases").
		Body(roleBase).
		Do().
		Into(result)
	return
}

// Update takes the representation of a roleBase and updates it. Returns the server's representation of the roleBase, and an error, if there is any.
func (c *roleBases) Update(roleBase *v1alpha2.RoleBase) (result *v1alpha2.RoleBase, err error) {
	result = &v1alpha2.RoleBase{}
	err = c.client.Put().
		Resource("rolebases").
		Name(roleBase.Name).
		Body(roleBase).
		Do().
		Into(result)
	return
}

// Delete takes name of the roleBase and deletes it. Returns an error if one occurs.
func (c *roleBases) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("rolebases").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *roleBases) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("rolebases").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched roleBase.
func (c *roleBases) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha2.RoleBase, err error) {
	result = &v1alpha2.RoleBase{}
	err = c.client.Patch(pt).
		Resource("rolebases").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
