/*
Copyright 2020 The KubeSphere Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1beta1 "kubesphere.io/kubesphere/pkg/apis/types/v1beta1"
)

// FakeFederatedUsers implements FederatedUserInterface
type FakeFederatedUsers struct {
	Fake *FakeTypesV1beta1
	ns   string
}

var federatedusersResource = schema.GroupVersionResource{Group: "types.kubefed.io", Version: "v1beta1", Resource: "federatedusers"}

var federatedusersKind = schema.GroupVersionKind{Group: "types.kubefed.io", Version: "v1beta1", Kind: "FederatedUser"}

// Get takes name of the federatedUser, and returns the corresponding federatedUser object, and an error if there is any.
func (c *FakeFederatedUsers) Get(name string, options v1.GetOptions) (result *v1beta1.FederatedUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedusersResource, c.ns, name), &v1beta1.FederatedUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedUser), err
}

// List takes label and field selectors, and returns the list of FederatedUsers that match those selectors.
func (c *FakeFederatedUsers) List(opts v1.ListOptions) (result *v1beta1.FederatedUserList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedusersResource, federatedusersKind, c.ns, opts), &v1beta1.FederatedUserList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.FederatedUserList{ListMeta: obj.(*v1beta1.FederatedUserList).ListMeta}
	for _, item := range obj.(*v1beta1.FederatedUserList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedUsers.
func (c *FakeFederatedUsers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedusersResource, c.ns, opts))

}

// Create takes the representation of a federatedUser and creates it.  Returns the server's representation of the federatedUser, and an error, if there is any.
func (c *FakeFederatedUsers) Create(federatedUser *v1beta1.FederatedUser) (result *v1beta1.FederatedUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedusersResource, c.ns, federatedUser), &v1beta1.FederatedUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedUser), err
}

// Update takes the representation of a federatedUser and updates it. Returns the server's representation of the federatedUser, and an error, if there is any.
func (c *FakeFederatedUsers) Update(federatedUser *v1beta1.FederatedUser) (result *v1beta1.FederatedUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedusersResource, c.ns, federatedUser), &v1beta1.FederatedUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedUser), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFederatedUsers) UpdateStatus(federatedUser *v1beta1.FederatedUser) (*v1beta1.FederatedUser, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(federatedusersResource, "status", c.ns, federatedUser), &v1beta1.FederatedUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedUser), err
}

// Delete takes name of the federatedUser and deletes it. Returns an error if one occurs.
func (c *FakeFederatedUsers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedusersResource, c.ns, name), &v1beta1.FederatedUser{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedUsers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedusersResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1beta1.FederatedUserList{})
	return err
}

// Patch applies the patch and returns the patched federatedUser.
func (c *FakeFederatedUsers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.FederatedUser, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedusersResource, c.ns, name, pt, data, subresources...), &v1beta1.FederatedUser{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.FederatedUser), err
}
