// Code generated by client-gen. DO NOT EDIT.

package v1alpha2

import (
	"time"

	v1alpha2 "istio.io/client-go/pkg/apis/config/v1alpha2"
	scheme "istio.io/client-go/pkg/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AttributeManifestsGetter has a method to return a AttributeManifestInterface.
// A group's client should implement this interface.
type AttributeManifestsGetter interface {
	AttributeManifests(namespace string) AttributeManifestInterface
}

// AttributeManifestInterface has methods to work with AttributeManifest resources.
type AttributeManifestInterface interface {
	Create(*v1alpha2.AttributeManifest) (*v1alpha2.AttributeManifest, error)
	Update(*v1alpha2.AttributeManifest) (*v1alpha2.AttributeManifest, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha2.AttributeManifest, error)
	List(opts v1.ListOptions) (*v1alpha2.AttributeManifestList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha2.AttributeManifest, err error)
	AttributeManifestExpansion
}

// attributeManifests implements AttributeManifestInterface
type attributeManifests struct {
	client rest.Interface
	ns     string
}

// newAttributeManifests returns a AttributeManifests
func newAttributeManifests(c *ConfigV1alpha2Client, namespace string) *attributeManifests {
	return &attributeManifests{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the attributeManifest, and returns the corresponding attributeManifest object, and an error if there is any.
func (c *attributeManifests) Get(name string, options v1.GetOptions) (result *v1alpha2.AttributeManifest, err error) {
	result = &v1alpha2.AttributeManifest{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("attributemanifests").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AttributeManifests that match those selectors.
func (c *attributeManifests) List(opts v1.ListOptions) (result *v1alpha2.AttributeManifestList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha2.AttributeManifestList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("attributemanifests").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested attributeManifests.
func (c *attributeManifests) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("attributemanifests").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a attributeManifest and creates it.  Returns the server's representation of the attributeManifest, and an error, if there is any.
func (c *attributeManifests) Create(attributeManifest *v1alpha2.AttributeManifest) (result *v1alpha2.AttributeManifest, err error) {
	result = &v1alpha2.AttributeManifest{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("attributemanifests").
		Body(attributeManifest).
		Do().
		Into(result)
	return
}

// Update takes the representation of a attributeManifest and updates it. Returns the server's representation of the attributeManifest, and an error, if there is any.
func (c *attributeManifests) Update(attributeManifest *v1alpha2.AttributeManifest) (result *v1alpha2.AttributeManifest, err error) {
	result = &v1alpha2.AttributeManifest{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("attributemanifests").
		Name(attributeManifest.Name).
		Body(attributeManifest).
		Do().
		Into(result)
	return
}

// Delete takes name of the attributeManifest and deletes it. Returns an error if one occurs.
func (c *attributeManifests) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("attributemanifests").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *attributeManifests) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("attributemanifests").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched attributeManifest.
func (c *attributeManifests) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha2.AttributeManifest, err error) {
	result = &v1alpha2.AttributeManifest{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("attributemanifests").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
