// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "istio.io/client-go/pkg/apis/rbac/v1alpha1"
	scheme "istio.io/client-go/pkg/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterRbacConfigsGetter has a method to return a ClusterRbacConfigInterface.
// A group's client should implement this interface.
type ClusterRbacConfigsGetter interface {
	ClusterRbacConfigs() ClusterRbacConfigInterface
}

// ClusterRbacConfigInterface has methods to work with ClusterRbacConfig resources.
type ClusterRbacConfigInterface interface {
	Create(*v1alpha1.ClusterRbacConfig) (*v1alpha1.ClusterRbacConfig, error)
	Update(*v1alpha1.ClusterRbacConfig) (*v1alpha1.ClusterRbacConfig, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.ClusterRbacConfig, error)
	List(opts v1.ListOptions) (*v1alpha1.ClusterRbacConfigList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ClusterRbacConfig, err error)
	ClusterRbacConfigExpansion
}

// clusterRbacConfigs implements ClusterRbacConfigInterface
type clusterRbacConfigs struct {
	client rest.Interface
}

// newClusterRbacConfigs returns a ClusterRbacConfigs
func newClusterRbacConfigs(c *RbacV1alpha1Client) *clusterRbacConfigs {
	return &clusterRbacConfigs{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterRbacConfig, and returns the corresponding clusterRbacConfig object, and an error if there is any.
func (c *clusterRbacConfigs) Get(name string, options v1.GetOptions) (result *v1alpha1.ClusterRbacConfig, err error) {
	result = &v1alpha1.ClusterRbacConfig{}
	err = c.client.Get().
		Resource("clusterrbacconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterRbacConfigs that match those selectors.
func (c *clusterRbacConfigs) List(opts v1.ListOptions) (result *v1alpha1.ClusterRbacConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ClusterRbacConfigList{}
	err = c.client.Get().
		Resource("clusterrbacconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterRbacConfigs.
func (c *clusterRbacConfigs) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clusterrbacconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a clusterRbacConfig and creates it.  Returns the server's representation of the clusterRbacConfig, and an error, if there is any.
func (c *clusterRbacConfigs) Create(clusterRbacConfig *v1alpha1.ClusterRbacConfig) (result *v1alpha1.ClusterRbacConfig, err error) {
	result = &v1alpha1.ClusterRbacConfig{}
	err = c.client.Post().
		Resource("clusterrbacconfigs").
		Body(clusterRbacConfig).
		Do().
		Into(result)
	return
}

// Update takes the representation of a clusterRbacConfig and updates it. Returns the server's representation of the clusterRbacConfig, and an error, if there is any.
func (c *clusterRbacConfigs) Update(clusterRbacConfig *v1alpha1.ClusterRbacConfig) (result *v1alpha1.ClusterRbacConfig, err error) {
	result = &v1alpha1.ClusterRbacConfig{}
	err = c.client.Put().
		Resource("clusterrbacconfigs").
		Name(clusterRbacConfig.Name).
		Body(clusterRbacConfig).
		Do().
		Into(result)
	return
}

// Delete takes name of the clusterRbacConfig and deletes it. Returns an error if one occurs.
func (c *clusterRbacConfigs) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusterrbacconfigs").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterRbacConfigs) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clusterrbacconfigs").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched clusterRbacConfig.
func (c *clusterRbacConfigs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ClusterRbacConfig, err error) {
	result = &v1alpha1.ClusterRbacConfig{}
	err = c.client.Patch(pt).
		Resource("clusterrbacconfigs").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
