// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "istio.io/client-go/pkg/apis/rbac/v1alpha1"
	scheme "istio.io/client-go/pkg/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ServiceRoleBindingsGetter has a method to return a ServiceRoleBindingInterface.
// A group's client should implement this interface.
type ServiceRoleBindingsGetter interface {
	ServiceRoleBindings(namespace string) ServiceRoleBindingInterface
}

// ServiceRoleBindingInterface has methods to work with ServiceRoleBinding resources.
type ServiceRoleBindingInterface interface {
	Create(*v1alpha1.ServiceRoleBinding) (*v1alpha1.ServiceRoleBinding, error)
	Update(*v1alpha1.ServiceRoleBinding) (*v1alpha1.ServiceRoleBinding, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.ServiceRoleBinding, error)
	List(opts v1.ListOptions) (*v1alpha1.ServiceRoleBindingList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ServiceRoleBinding, err error)
	ServiceRoleBindingExpansion
}

// serviceRoleBindings implements ServiceRoleBindingInterface
type serviceRoleBindings struct {
	client rest.Interface
	ns     string
}

// newServiceRoleBindings returns a ServiceRoleBindings
func newServiceRoleBindings(c *RbacV1alpha1Client, namespace string) *serviceRoleBindings {
	return &serviceRoleBindings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the serviceRoleBinding, and returns the corresponding serviceRoleBinding object, and an error if there is any.
func (c *serviceRoleBindings) Get(name string, options v1.GetOptions) (result *v1alpha1.ServiceRoleBinding, err error) {
	result = &v1alpha1.ServiceRoleBinding{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("servicerolebindings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ServiceRoleBindings that match those selectors.
func (c *serviceRoleBindings) List(opts v1.ListOptions) (result *v1alpha1.ServiceRoleBindingList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ServiceRoleBindingList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("servicerolebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested serviceRoleBindings.
func (c *serviceRoleBindings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("servicerolebindings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a serviceRoleBinding and creates it.  Returns the server's representation of the serviceRoleBinding, and an error, if there is any.
func (c *serviceRoleBindings) Create(serviceRoleBinding *v1alpha1.ServiceRoleBinding) (result *v1alpha1.ServiceRoleBinding, err error) {
	result = &v1alpha1.ServiceRoleBinding{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("servicerolebindings").
		Body(serviceRoleBinding).
		Do().
		Into(result)
	return
}

// Update takes the representation of a serviceRoleBinding and updates it. Returns the server's representation of the serviceRoleBinding, and an error, if there is any.
func (c *serviceRoleBindings) Update(serviceRoleBinding *v1alpha1.ServiceRoleBinding) (result *v1alpha1.ServiceRoleBinding, err error) {
	result = &v1alpha1.ServiceRoleBinding{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("servicerolebindings").
		Name(serviceRoleBinding.Name).
		Body(serviceRoleBinding).
		Do().
		Into(result)
	return
}

// Delete takes name of the serviceRoleBinding and deletes it. Returns an error if one occurs.
func (c *serviceRoleBindings) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("servicerolebindings").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *serviceRoleBindings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("servicerolebindings").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched serviceRoleBinding.
func (c *serviceRoleBindings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ServiceRoleBinding, err error) {
	result = &v1alpha1.ServiceRoleBinding{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("servicerolebindings").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
